/*

  P-Code interpreter (to run the apple pascal system)
  Copyright (C) 2000 Mario Klebsch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

typedef unsigned char	byte;
typedef unsigned short	word;
typedef signed short	Integer;

word Pop(void);
void Push(word Value);
void XeqError(word err);
void IoError(word Result);

void ProcessNative(word JTab);

void IoError	(word Result);
void UnitRead	(word Unit, word Addr, Integer AddrOffset,
		 word Len, word Block, word Mode);
void UnitWrite	(word Unit, word Addr, Integer AddrOffset,
		 word Len, word Block, word Mode);
void UnitClear	(word Unit);
void UnitStat	(word Unit, word Addr, Integer AddrOffset, word Dummy);
word UnitBusy	(word Unit);
void UnitWait	(word Unit);
void UnitInit	(void);
void UnitFinish	(void);

void panic(char *Msg, ...);
void warning(char *Msg, ...);
void XeqError(word err);

extern word Syscom;

#define SYSCOM_SIZE	170
#define IORSLT		WordIndexed(Syscom,0)
#define XEQERR		WordIndexed(Syscom,1)
#define SYSUNIT		WordIndexed(Syscom,2)
#define BUGSTATE	WordIndexed(Syscom,3)
#define GDIRP		WordIndexed(Syscom,4)

#define STKBASE		WordIndexed(Syscom,6)
#define LASTMP		WordIndexed(Syscom,7)
#define BOMPROC		WordIndexed(Syscom,8)
#define BOMSEG		WordIndexed(Syscom,9)

#define BOMIPC		WordIndexed(Syscom,11)

/* #define ???		WordIndexed(Syscom,29)*/

#define SEG_ENTRY_LEN	3
#define SEG_UNIT(s)	WordIndexed(Syscom, 48 + SEG_ENTRY_LEN*(s))
#define SEG_BLOCK(s)	WordIndexed(SEG_UNIT(s),1)
#define SEG_SIZE(s)	WordIndexed(SEG_UNIT(s),2)

